unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    LabeledEdit3: TLabeledEdit;
    Edit3: TEdit;
    Label3: TLabel;
    LabeledEdit4: TLabeledEdit;
    CheckBox1: TCheckBox;
    LabeledEdit5: TLabeledEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure Elliptic;
    function Datainput(var m, X, A: Extended): boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses system.Math;

function TForm1.Datainput(var m, X, A: Extended): boolean;
var
  Ch: integer;
  Q, k: extended;
begin
  Result := False;
//  k := 0;
  if not checkbox1.Checked then begin
    val(LabeledEdit1.Text, K, CH);
    if Ch <> 0 then begin
      application.MessageBox('S(k)lł͂܂B','K(S)', 0);
      exit;
    end;
    m := k * k;
  end
  else begin
    val(LabeledEdit4.Text, m, CH);
    if Ch <> 0 then begin
      application.MessageBox('p[^[(m)lł͂܂B','K(S)', 0);
      exit;
    end;
//    if m > 0 then k := sqrt(m);
  end;
//  if (K > 1) or (K < -1) then begin
//    application.MessageBox('S͈͊OłB','K(S)', 0);
//   exit;
//  end;
  val(LabeledEdit2.Text, Q, CH);
  if Ch <> 0 then begin
    application.MessageBox('ϕ͈̔͂lł͂܂B','X(ϕ͈)', 0);
    exit;
  end;
  X := sin(Q / 180 * pi);
  val(LabeledEdit3.Text, A, CH);
  if Ch <> 0 then begin
    application.MessageBox('O탿̒llł͂܂B','O ', 0);
    exit;
  end;
  Result := True;
end;

// ϕvZ̓R[r̕W`
procedure TForm1.Elliptic;
const
  N = 10000000;
var
  i, J    : integer;
  X       : Extended;
  m, t2   : Extended;
  t, dx   : Extended;
  Fxk     : Extended;
  Exk     : Extended;
  Fxka    : Extended;
  S1, S2  : Extended;
  S3, A1  : Extended;
  LA, LB  : Extended;
  ms      : Extended;
begin
  if not Datainput(m, X, A1) then exit;
  t := 0;
  dx := 1 / N;
  J := Round(abs(X) / dx);              // X(ϕ͈)ɏꍇ J()[ɂȂ̂
  if J = 0 then X := 0;                 // ̎́AX=0Ƃ܂B
  if X = 0 then begin
    Edit1.Text := '0';
    Edit2.Text := '0';
    Edit3.Text := '0';
    exit;
  end;
  dx := X / J;
  Exk  := 0;
  Fxk  := 0;
  Fxka := 0;
  ms := 0.5;                            // vZԓ_
  if ABS(X) = 1 then ms := 0.697313;
  for I := 0 to J - 1 do begin          // ϕ͈̔͂̂ ms * dx  X - dx * ms łB
    t := (I + ms)  * dx;                // vZ_𒆊ԓ_Ƃ鎖ŌvZxƓ
    t2 := t * t;                        // X=1 ̎̃[ł̏Z̖h~܂B
    S1  := (1 - t2);
    S2 := (1 - m * t2);
    S3 := (1 - A1 * t2);
    if S2 < 0 then break;
    LA := sqrt(S2 / S1);
    Exk := Exk + LA * dx;                                   // ȉ~ϕ
    LB := sqrt(S1 * S2);
    if (m < 1) or (abs(X) < 1) then begin
        Fxk  := Fxk  + dx / LB;                             // ȉ~ϕ
        if S3 > 0 then Fxka := Fxka + dx / LB / S3;         // Oȉ~ϕ
    end;
  end;
  t2 := arcsin(t - dx) / pi * 180;
  labelededit5.Text := floatTostr(t2);
  if (m = 1) and (abs(X) = 1) then begin   // R[r̕W`̏ꍇ X = 1 Ł@ꂪ[
    Edit1.Text := '';                     // ɂȂ̂łAK=1  X=1̎̂݁Ƃ܂B
    Edit3.Text := '';                     // Wh̕W`ɍ킹܂B
  end
  else begin
    Edit1.Text := floattostr(Fxk);
    Edit3.Text := floattostr(Fxka);
  end;
  Edit2.Text := floattostr(Exk);
  if A1 * X * X = 1 then Edit3.Text := '';
  if A1 * X * X > 1 then Edit3.Text := '̒l傫܂B';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Elliptic;
end;

end.

