unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    LabeledEdit3: TLabeledEdit;
    Edit3: TEdit;
    Label3: TLabel;
    CheckBox1: TCheckBox;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure Elliptic;
    function Datainput(var m, Q, A: Extended): boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function TForm1.Datainput(var m, Q, A: Extended): boolean;
var
  Ch: integer;
  k : Extended;
begin
  k := 0;
  Result := False;
  if not checkbox1.Checked then begin
    val(LabeledEdit1.Text, K, CH);
    if Ch <> 0 then begin
      application.MessageBox('S(k)lł͂܂B','K(S)', 0);
      exit;
    end;
    m := k * k;
  end
  else begin
    val(LabeledEdit4.Text, m, CH);
    if Ch <> 0 then begin
      application.MessageBox('p[^[(m)lł͂܂B','m(p[^[)', 0);
      exit;
    end;
    if m > 0 then k := sqrt(m);
  end;
//  if abs(K) > 1 then begin
//    application.MessageBox('S(k)͈͊OłB','K(S)', 0);
//    exit;
//  end;
  val(LabeledEdit2.Text, Q, CH);
  if Ch <> 0 then begin
    application.MessageBox('ϕ͈̔͂lł͂܂B','(ϕ͈)', 0);
    exit;
  end;
  if abs(Q) > 360 then begin
    application.MessageBox('ϕ͈̔abs(X)傫܂','(ϕ͈)', 0);
    exit;
  end;
  val(LabeledEdit3.Text, A, CH);
  if Ch <> 0 then begin
    application.MessageBox('O탿̒llł͂܂B','O ', 0);
    exit;
  end;
  Result := True;
end;

// ϕvZ̓Wh̕W`
procedure TForm1.Elliptic;
const
  N = 4000000;
var
  i, J      : integer;
  Q, st     : Extended;
  m, t, t2  : Extended;
  Pq, dq    : Extended;
  Fxk       : Extended;
  Exk       : Extended;
  Fxka      : Extended;
  S1, S2    : Extended;
  a, t3     : Extended;
  LA, LB    : Extended;
  ms        : Extended;
  ps2       : Extended;
begin
  if not Datainput(m, Q, a) then exit;
  t := 0;
  ps2 := pi / 2;
  Pq := Q / 180 * pi;
  J := abs(round(Pq * N));      // Q(ϕ͈)ɏꍇ J()[ɂȂ̂
  if J = 0 then Q := 0;         // ̎́AQ=0Ƃ܂B
  if Q = 0 then begin
    Edit1.Text := '0';
    Edit2.Text := '0';
    Edit3.Text := '0';
    Edit3.Text := '0';
    exit;
  end;
  dq := Pq / J;
  Exk  := 0;
  Fxk  := 0;
  Fxka := 0;
  ms := 0.5;                    // vZԓ_
  for I := 0 to J - 1 do begin  // ϕ͈̔͂̂ ms * dx  X - dx * ms łB
    t := (I + ms)  * dq;        // ԒlŌvZvZx܂B
    st := sin(t);               // sin
    t2 := st * st;              // sin^2
    t3 := t2 * m;               // k^2*sin^2
    S1 := (1 - t3);             // 1-k^2*sin^2
    S2 := (1 - a * t2);         // 1-a*sin^2
    if S1 < 0 then break;
    LA := sqrt(S1);             // (1-k^2*sin^2)

    Exk := Exk + LA * dq;       // ȉ~ϕ
    LB := S2 * LA;              // (1-a*sin^2) * (1-k^2*sin^2)
    if (m < 1) or (abs(Pq) < ps2) then begin  // (K < 1) or ( < 90)
      Fxk := Fxk  + dq / LA;                  // ȉ~ϕ
      if LB > 0 then Fxka := Fxka + dq / LB;  // Oȉ~ϕ
    end;
  end;
  q := (t - dq) / pi * 180;
  labelededit5.Text := floatTostr(q);
  if (m = 1) and (abs(Pq) >= ps2) then begin   // ȉ~ϕ
    Edit1.Text := '';
  end
  else Edit1.Text := floattostr(Fxk);

  Edit2.Text := floattostr(Exk);               // ȉ~ϕ

  Edit3.Text := floattostr(Fxka);              // Oȉ~ϕ
  if (abs(pq) >= ps2) then begin               //  >= 90
    if (m = 1) or (a = 1) then  Edit3.Text := '';
    if (a > 1) then Edit3.Text :='̒l傫܂B';
  end
  else begin                                   //  < 90
    S2 := sin(pq) * sin(pq) * a;               // a * sin^2()
    if (S2 > 1) then Edit3.Text := '̒l傫܂B';
    if (S2 = 1) then Edit3.Text := '';       // Z덷ɂ蔭Ⴂ
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Elliptic;
end;

end.

