// 2021/ 1 / 6 a͂̒ǉ
// 2020/12/20 [`̐
// 2020/12/10 ̏o͂ɕǉ

//--------------------------------------------------------------------------------------
// Oȉ~ϕ̃vO
// {ZMPArithgpĂ܂B
// uses  mp_types, mp_real@̒ǉKvłB
// MPArith ɂĂ͉LQƂĂB
// "https://web.archive.org/web/20181215233944/http://wolfgang-ehrhardt.de/mp_intro.html"
//---------------------------------------------------------------------------------------
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, mp_types, mp_real, mp_base;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    k_Edit: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label8: TLabel;
    aEdit: TLabeledEdit;
    bEdit: TLabeledEdit;
    RadioButton3: TRadioButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private 錾 }
    function  datacheck: boolean;
    procedure Ddatainput;
    procedure calc_Third_elliptic_integral(a, qb, m: double);
    procedure Mdatainput;
    procedure Mcalc_Third_elliptic_integral(ma, mqb, mm: mp_float);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Math;

var
  btn2F  : boolean = False;     // ϕ͈͂w̌vZtO
  Xstr   : string;              // wtextobNAbv

  // ϕ͈͂w̃(deg)ϊl
  MpXtoDeg : mp_float;
  DbXtoDeg : double;


// Carlson's Elliptic Integral RJ
procedure MRJ(x11, y11, z11, p11: mp_float; var rj: mp_float);
var
  s, fa, rk       : mp_float;
  la, mu, ss      : mp_float;
  al, be          : mp_float;
  r1, a1, b1      : mp_float;
  a2, b2, mv, s1  : mp_float;
  rc, r0          : mp_float;
  s12, s13, s14   : mp_float;
  s15, s16        : mp_float;
  x2, y2, z2      : mp_float;
  x3, y3, z3      : mp_float;
  s2, s3, p2, p3  : mp_float;
  s4, s5          : mp_float;
  x31, y31, z31, p31 : mp_float;
  s22, s23, s2s3  : mp_float;
  t0, t1, t2, t3  : mp_float;
  one             : mp_float;
  x1, y1, z1, p1  : mp_float;

  procedure rcab;
  begin
//    rc := 1;
    mpf_set1(rc);
//    a1 := al;
    mpf_copy(al, a1);
//    b1 := be;
    mpf_copy(be, b1);
    repeat
//      r1 := rc;
      mpf_copy(rc, r1);
//      la := 2 * sqrt(a1 * b1) + b1;
      mpf_mul(a1, b1, t0);
      mpf_sqrt(t0, t1);
      mpf_mul_int(t1, 2, t2);
      mpf_add(t2, b1, la);
//      a2 := (a1 + la) / 4;
      mpf_add(a1, la, t3);
      mpf_div_int(t3, 4, a2);
//      b2 := (b1 + la) / 4;
      mpf_add(b1, la, t0);
      mpf_div_int(t0, 4, b2);
//      mv := (a1 + 2 * b1) / 3;
      mpf_mul_int(b1, 2, t1);
      mpf_add(t1, a1, t2);
      mpf_div_int(t2, 3, mv);
//      s1 := (b1 - a1) / (3 * mv);
      mpf_sub(b1, a1, t3);
      mpf_mul_int(mv, 3, t0);
      mpf_div(t3, t0, s1);
//      s12 := s1 * s1;
      mpf_sqr(s1, s12);
//      s13 := s12 * s1;
      mpf_mul(s12, s1, s13);
//      s14 := s13 * s1;
      mpf_mul(s13, s1, s14);
//      s15 := s14 * s1;
      mpf_mul(s14, s1, s15);
//      s16 := s15 * s1;
      mpf_mul(s15, s1, s16);
//      rc := (1 + 3 * s12 / 10 + s13 / 7 + 3 * s14 / 8 + 9 * s15 / 22 + 159 * s16 / 208) / sqrt(mv);
      mpf_mul_int(s12, 3, t0);
      mpf_div_int(t0, 10, t1);    // 3 * s12 / 10
      mpf_div_int(s13, 7, t2);    // s13 / 7
      mpf_mul_int(s14, 3, t0);
      mpf_div_int(t0, 8,  t3);    // 3 * s14 / 8
      mpf_add(one, t1, t0);       // 1 + 3 * s12 / 10
      mpf_add(t0, t2, t1);        // 1 + 3 * s12 / 10 + s13 / 7
      mpf_add(t1, t3, t0);        // 1 + 3 * s12 / 10 + s13 / 7 + 3 * s14 / 8
      mpf_mul_int(s15, 9, t1);
      mpf_div_int(t1, 22, t2);    // 9 * s15 / 22
      mpf_mul_int(s16, 159, t1);
      mpf_div_int(t1, 208, t3);   // 159 * s16 / 208
      mpf_add(t0, t2, t1);        // 1 + 3 * s12 / 10 + s13 / 7 + 3 * s14 / 8 + 9 * s15 / 22
      mpf_add(t1, t3, t0);        // 1 + 3 * s12 / 10 + s13 / 7 + 3 * s14 / 8 + 9 * s15 / 22 + 159 * s16 / 208
      mpf_sqrt(mv, t1);           // sqrt(mv)
      mpf_div(t0, t1, rc);        // / sqrt(mv)
//      a1 := a2;
      mpf_copy(a2, a1);
//      b1 := b2;
      mpf_copy(b2, b1);
//    until r1 = rc;
    until mpf_is_eq(r1, rc);
  end;

  procedure sadd;
  begin
//    x31 := x31 * x3;
    mpf_mul(x31, x3, x31);
//    y31 := y31 * y3;
    mpf_mul(y31, y3, y31);
//    z31 := z31 * z3;
    mpf_mul(z31, z3, z31);
//    p31 := p31 * p3;
    mpf_mul(p31, p3, p31);
//    ss := (x31 + y31 + z31 + p31);
    mpf_add(x31, y31, t0);
    mpf_add(z31, p31, t1);
    mpf_add(t0, t1, ss);
  end;

begin
  mpf_init3(s, fa, rk);
  mpf_init3(la, mu, ss);
  mpf_init2(al, be);
  mpf_init3(r1, a1, b1);
  mpf_init4(a2, b2, mv, s1);
  mpf_init2(rc, r0);
  mpf_init3(s12, s13, s14);
  mpf_init2(s15, s16);
  mpf_init3(x2, y2, z2);
  mpf_init3(x3, y3, z3);
  mpf_init4(s2, s3, p2, p3);
  mpf_init2(s4, s5);
  mpf_init4(x31, y31, z31, p31);
  mpf_init3(s22, s23, s2s3);
  mpf_init4(t0, t1, t2, t3);
  mpf_init(one);
  mpf_init4(x1, y1, z1, p1);

  mpf_copy(x11, x1);
  mpf_copy(y11, y1);
  mpf_copy(z11, z1);
  mpf_copy(p11, p1);

  mpf_set1(one);
//  s := 0;
  mpf_set0(s);
//  fa := 3;
  mpf_set_int(fa, 3);
//  rj := 0;
  mpf_set0(rj);
  repeat
//    r0 := rj;
    mpf_copy(rj, r0);
//    la := sqrt(x1 * y1) + sqrt(x1 * z1) + sqrt(y1 * z1);
    mpf_mul(x1, y1, t0);
    mpf_sqrt(t0, t1);
    mpf_mul(x1, z1, t0);
    mpf_sqrt(t0, t2);
    mpf_mul(y1, z1, t0);
    mpf_sqrt(t0, t3);
    mpf_add(t1, t2, t0);
    mpf_add(t0, t3, la);
//    mu := (x1 + y1 + z1 + 2 * p1) / 5;
    mpf_mul_int(p1, 2, t0);
    mpf_add(t0, x1, t1);
    mpf_add(t1, y1, t0);
    mpf_add(t0, z1, t1);
    mpf_div_int(t1, 5, mu);
//    x2 := (x1 + la) / 4;
    mpf_add(x1, la, t0);
    mpf_div_int(t0, 4, x2);
//    y2 := (y1 + la) / 4;
    mpf_add(y1, la, t0);
    mpf_div_int(t0, 4, y2);
//    z2 := (z1 + la) / 4;
    mpf_add(z1, la, t0);
    mpf_div_int(t0, 4, z2);
//    p2 := (p1 + la) / 4;
    mpf_add(p1, la, t0);
    mpf_div_int(t0, 4, p2);
//    x3 := 1 - x1 / mu;
    mpf_div(x1, mu, t1);
    mpf_sub(one, t1, x3);
//    y3 := 1 - y1 / mu;
    mpf_div(y1, mu, t1);
    mpf_sub(one, t1, y3);
//    z3 := 1 - z1 / mu;
    mpf_div(z1, mu, t1);
    mpf_sub(one, t1, z3);
//    p3 := 1 - p1 / mu;
    mpf_div(p1, mu, t1);
    mpf_sub(one, t1, p3);
//    x31 := x3;
    mpf_copy(x3, x31);
//    y31 := y3;
    mpf_copy(y3, y31);
//    z31 := z3;
    mpf_copy(z3, z31);
//    p31 := 2 * p3;
    mpf_mul_int(p3, 2, p31);
    sadd;
//    s2 := ss / 4;
    mpf_div_int(ss, 4, s2);
    sadd;
//    s3 := ss / 6;
    mpf_div_int(ss, 6, s3);
    sadd;
//    s4 := ss / 8;
    mpf_div_int(ss, 8, s4);
    sadd;
//    s5 := ss / 10;
    mpf_div_int(ss, 10, s5);
//    al := (sqrt(x1) + sqrt(y1) + sqrt(z1)) * p1 + sqrt(x1 * y1 * z1);
    mpf_sqrt(x1, t0);
    mpf_sqrt(y1, t1);
    mpf_sqrt(z1, t2);
    mpf_add(t0, t1, t3);
    mpf_add(t3, t2, t0);
    mpf_mul(t0, p1, t1);    // (sqrt(x1) + sqrt(y1) + sqrt(z1)) * p1
    mpf_mul(x1, y1, t0);
    mpf_mul(t0, z1, t2);
    mpf_sqrt(t2, t0);       // sqrt(x1 * y1 * z1)
    mpf_add(t1, t0, t2);    // (sqrt(x1) + sqrt(y1) + sqrt(z1)) * p1 + sqrt(x1 * y1 * z1)
//    al := al * al;
    mpf_sqr(t2, al);
//    be := p1 * (p1 + la) * (p1 + la);
    mpf_add(p1, la, t0);
    mpf_sqr(t0, t1);
    mpf_mul(t1, p1, be);
    rcab;
//    s22 := 3 * s2 * s2 / 22;
    mpf_sqr(s2, t0);
    mpf_mul_int(t0, 3, t1);
    mpf_div_int(t1, 22, s22);
//    s23 := s2 * s2 * s2 / 10;
    mpf_expt_int(s2, 3, t0);
    mpf_div_int(t0, 10, s23);
//    s2s3 := s2 * s3 * 3 / 13;
    mpf_mul(s2, s3, t0);
    mpf_mul_int(t0, 3, t1);
    mpf_div_int(t1, 13, s2s3);
//    s := s + fa * rc;
    mpf_mul(fa, rc, t1);
    mpf_add(s, t1, s);
//    rk := 1 + 3 * s2 / 7 + s3 / 3 + s22 + s2s3 + 3 * s4 / 11 + 3 * s5 / 13 - s23;
    mpf_mul_int(s2, 3, t0);
    mpf_div_int(t0, 7, t1);   // 3 * s2 / 7
    mpf_div_int(s3, 3, t2);   // s3 / 3
    mpf_add(one, t1, t0);     // 1 + 3 * s2 / 7                           t0
    mpf_add(t0, t2, t3);      // 1 + 3 * s2 / 7 + s3 / 3                  t3
    mpf_add(t3, s22, t1);     // 1 + 3 * s2 / 7 + s3 / 3 + s22            t1
    mpf_add(t1, s2s3, t3);    // 1 + 3 * s2 / 7 + s3 / 3 + s22 + s2s3     t3
    mpf_mul_int(s4, 3, t0);
    mpf_div_int(t0, 11, t1);  // 3 * s4 / 11
    mpf_mul_int(s5, 3, t0);
    mpf_div_int(t0, 13, t2);  // 3 * s5 / 13
    mpf_add(t3, t1, t0);      // 1 + 3 * s2 / 7 + s3 / 3 + s22 + s2s3 + 3 * s4 / 11
    mpf_add(t0, t2, t3);      // 1 + 3 * s2 / 7 + s3 / 3 + s22 + s2s3 + 3 * s4 / 11  + 3 * s5 / 13
    mpf_sub(t3, s23, rk);     // 1 + 3 * s2 / 7 + s3 / 3 + s22 + s2s3 + 3 * s4 / 11  + 3 * s5 / 13 - s23
//    fa := fa / 4;
    mpf_div_int(fa, 4, fa);
//    mu := sqrt(1 / (mu * mu * mu));
    mpf_expt_int(mu, 3, t0);
    mpf_div(one, t0, t1);
    mpf_sqrt(t1, mu);
//    rj := s + fa / 4 * (rk + 3 * s3 * s3 / 10 + 3 * s2 * s4 / 5) * mu;
    mpf_div_int(fa, 4, t1);   // fa / 4
    mpf_sqr(s3, t0);
    mpf_mul_int(t0, 3, t3);
    mpf_div_int(t3, 10, t2);  // 3 * s3 * s3 / 10
    mpf_mul(s2, s4, t0);
    mpf_mul_int(t0, 3, t3);
    mpf_div_int(t3, 5, t0);   // 3 * s2 * s4 / 5
    mpf_add(rk, t2, t3);      // rk + 3 * s3 * s3 / 10
    mpf_add(t3, t0, t2);      // rk + 3 * s3 * s3 / 10 + 3 * s2 * s4 / 5
    mpf_mul(t1, t2, t3);      // fs / 4 * (rk + 3 * s3 * s3 / 10 + 3 * s2 * s4 / 5)
    mpf_mul(t3, mu, t0);      // fs / 4 * (rk + 3 * s3 * s3 / 10 + 3 * s2 * s4 / 5) * mu
    mpf_add(s, t0, rj);       // s + fs / 4 * (rk + 3 * s3 * s3 / 10 + 3 * s2 * s4 / 5) * mu
//    x1 := x2;
    mpf_copy(x2, x1);
//    y1 := y2;
    mpf_copy(y2, y1);
//    z1 := z2;
    mpf_copy(z2, z1);
//    p1 := p2;
    mpf_copy(p2, p1);
//  until rj = r0;
  until mpf_is_eq(rj, r0);
//  Edit2.Text := string(mpf_decimal(fa, 50));

  mpf_clear3(s, fa, rk);
  mpf_clear3(la, mu, ss);
  mpf_clear2(al, be);
  mpf_clear3(r1, a1, b1);
  mpf_clear4(a2, b2, mv, s1);
  mpf_clear2(rc, r0);
  mpf_clear3(s12, s13, s14);
  mpf_clear2(s15, s16);
  mpf_clear3(x2, y2, z2);
  mpf_clear3(x3, y3, z3);
  mpf_clear4(s2, s3, p2, p3);
  mpf_clear2(s4, s5);
  mpf_clear4(x31, y31, z31, p31);
  mpf_clear3(s22, s23, s2s3);
  mpf_clear4(t0, t1, t2, t3);
  mpf_clear(one);
  mpf_clear4(x1, y1, z1, p1);
end;

// Carlson's Elliptic Integral RF
procedure MRF(x11, y11, z11: mp_float; var rf: mp_float);
var
  la, mu      : mp_float;
  x2, y2, z2  : mp_float;
  x3, y3, z3  : mp_float;
  s2, s3      : mp_float;
  r0          : mp_float;
  s22, s23, s2s3, s32 : mp_float;
  one         : mp_float;
  t0, t1, t2  : mp_float;
  x1, y1, z1  : mp_float;
begin
  mpf_init2(la, mu);
  mpf_init3(x2, y2, z2);
  mpf_init3(x3, y3, z3);
  mpf_init2(s2, s3);
  mpf_init(r0);
  mpf_init4(s22, s23, s2s3, s32);
  mpf_init(one);
  mpf_init3(t0, t1, t2);
  mpf_init3(x1, y1, z1);

//  rf := 0;
  mpf_set0(rf);
  mpf_copy(x11, x1);
  mpf_copy(y11, y1);
  mpf_copy(z11, z1);
  repeat
//    r0 := rf;
    mpf_copy(rf, r0);
//    la := sqrt(x1 * y1) + sqrt(x1 * z1) + sqrt(y1 * z1);
    mpf_mul(x1, y1, s22);
    mpf_mul(x1, z1, s23);
    mpf_mul(y1, z1, s32);
    mpf_sqrt(s22, t0);
    mpf_sqrt(s23, t1);
    mpf_add(t0, t1, t2);
    mpf_sqrt(s32, t0);
    mpf_add(t2, t0, la);
//    mu := (x1 + y1 + z1) / 3;
    mpf_add(x1, y1, t2);
    mpf_add(t2, z1, t1);
    mpf_div_int(t1, 3, mu);
//    x2 := (x1 + la) / 4;
    mpf_add(x1, la, t0);
    mpf_div_int(t0, 4, x2);
//    y2 := (y1 + la) / 4;
    mpf_add(y1, la, t0);
    mpf_div_int(t0, 4, y2);
//    z2 := (z1 + la) / 4;
    mpf_add(z1, la, t0);
    mpf_div_int(t0, 4, z2);
    mpf_set1(one);
//    x3 := 1 - x2 / mu;
    mpf_div(x2, mu, t2);
    mpf_sub(one, t2, x3);
//    y3 := 1 - y2 / mu;
    mpf_div(y2, mu, t2);
    mpf_sub(one, t2, y3);
//    z3 := 1 - z2 / mu;
    mpf_div(z2, mu, t2);
    mpf_sub(one, t2, z3);
//    s2 := (x3 * x3 + y3 * y3 + z3 * z3) / 4;
    mpf_sqr(x3, t0);
    mpf_sqr(y3, t1);
    mpf_add(t0, t1, t2);
    mpf_sqr(z3, t0);
    mpf_add(t2, t0, t1);
    mpf_div_int(t1, 4, s2);
//    s3 := (x3 * x3 * x3 + y3 * y3 * y3 + z3 * z3 * z3) / 6;
    mpf_expt_int(x3, 3, t0);
    mpf_expt_int(y3, 3, t1);
    mpf_add(t0, t1, t2);
    mpf_expt_int(z3, 3, t0);
    mpf_add(t0, t2, t1);
    mpf_div_int(t1, 6, s3);
//    s22 := s2 * s2 / 6;
    mpf_sqr(s2, t0);
    mpf_div_int(t0, 6, s22);
//    s23 := 5 * s2 * s2 * s2 / 26;
    mpf_expt_int(s2, 3, t0);
    mpf_mul_int(t0, 5, t1);
    mpf_div_int(t1, 26, s23);
//    s32 := 3 * s3 * s3 / 26;
    mpf_sqr(s3, t0);
    mpf_mul_int(t0, 3, t1);
    mpf_div_int(t1, 26, s32);
//    s2s3 := s2 * s3 * 3 / 11;
    mpf_mul(s2, s3, t0);
    mpf_mul_int(t0, 3, t1);
    mpf_div_int(t1, 11, s2s3);
//    rf := (1 + s2 / 5 + s3 / 7 + s22 + s2s3 + s23 + s32) / sqrt(mu);
    mpf_div_int(s2, 5, t0);
    mpf_div_int(s3, 7, t1);
    mpf_add(t0, t1, t2);
    mpf_add(t2, one, t1);
    mpf_add(t1, s22, t0);
    mpf_add(t0, s2s3, t2);
    mpf_add(t2, s23, t1);
    mpf_add(t1, s32, t0);
    mpf_sqrt(mu, t2);
    mpf_div(t0, t2, rf);
//    x1 := x2;
    mpf_copy(x2, x1);
//    y1 := y2;
    mpf_copy(y2, y1);
//    z1 := z2;
    mpf_copy(z2, z1);
//  until rf = r0;
  until mpf_is_eq(rf, r0);

  mpf_clear2(la, mu);
  mpf_clear3(x2, y2, z2);
  mpf_clear3(x3, y3, z3);
  mpf_clear2(s2, s3);
  mpf_clear(r0);
  mpf_clear4(s22, s23, s2s3, s32);
  mpf_clear(one);
  mpf_clear3(t0, t1, t2);
  mpf_clear3(x1, y1, z1);
end;

// {@AAOȉ~ϕ
// ma       O
// mq      pxrad
// mm      p[^k^2
procedure TForm1.Mcalc_Third_elliptic_integral(ma, mqb, mm: mp_float);
label
  LEXIT,
  MNo2;
var
  J             : integer;
  mj            : mp_int;
  mq            : mp_float;
  ms, ms2, ms3  : mp_float;
  mc2           : mp_float;
  mrf0, mrj0    : mp_float;
  mafk, maek    : mp_float;
  m1mk2, m1mas2 : mp_float;
  mak90         : mp_float;
  mONE, mTMP    : mp_float;
  mfqk, mfek    : mp_float;
  mfqk90        : mp_float;
  meqk          : mp_float;
  meq           : mp_float;
  mps2          : mp_float;

  ALFRG         : Integer;      // OvZtO     0   1 }  2 Oa̒l Zs
  ALFQK         : Integer;      // vZtO     0   1 }
begin
  mp_init(mj);
  mpf_init(mq);
  mpf_init3(ms, ms2, ms3);
  mpf_init(mc2);
  mpf_init2(mrf0, mrj0);
  mpf_init2(mafk, maek);
  mpf_init2(m1mk2, m1mas2);
  mpf_init2(mONE, mTMP);
  mpf_init(mak90);
  mpf_init(meq);
  mpf_init(mps2);
  mpf_init2(mfqk, mfek);
  mpf_init(mfqk90);
  mpf_init(meqk);

// Oȉ~ϕ { -------------------------------------
  ALFRG := 0;
  ALFQK := 0;
  mpf_set_pi(mps2);                 // ΃Zbg
  mpf_div_int(mps2, 2, mps2);       //  / 2
  mpf_abs(mqb, mq);                 // q = abs()
  mpf_div(mq, mps2, mTMP);          // mTMP = q / ( / 2)
{
   ϕp90J = 1ɂȂȂꍇA'q = q + q * 2^(1-q.bitprec)) ƂČvZ܂B
  @ ( mpf_get_default_prec    Return current default (bit) precision, initial=240 )
  mpf_div(mq, mps2, mTMP); L7sƒu܂B
}
{
  J := mpf_get_default_prec;             // J = 240  default
  J := 1 - J;                            // 1 - J
  mpf_set_int(mTMP,J);                   // (1 - J) -> mp_float
  mpf_exp2(mTMP, mTMP);                  // EPSILON = 2^(1 - J)
  mpf_mul(mq, mTMP, mTMP);               //  q" = q * EPSILON
  mpf_add(mq, mTMP, mTMP);               // 'q = q + q"
  mpf_div(mTMP, mps2, mTMP);             // mTMP = 'q / (/2)
}
  mpf_trunc(mTMP, mj);              // _ȉ؂̂
  J := mp_get_int(mj);              // { -> integer
  if J > 0 then begin               // 90傫
    mpf_set1(ms2);                  // sin^2 = 1
  end
  else begin
    mpf_sin(mq, ms);                // sin
    mpf_sqr(ms, ms2);               // sin^2
  end;
  mpf_mul(mm, ms2, mTMP);           // k^2sin^2
  mpf_set1(mONE);                   // 1
  mpf_sub(mONE, mTMP, m1mk2);       // 1 - k^2sin^2
  mpf_mul(ma, ms2, mTMP);           // a*sin^2
  mpf_sub(mONE, mTMP, m1mas2);      // 1 - a*sin^2

  if s_mpf_is_le0(m1mas2) then begin  // (1 - a*sin^2) <= 0 Ȃ O폈
    if s_mpf_is0(m1mas2) then ALFRG := 1    // O큇-tO
                         else ALFRG := 2;   // O a(n) 傫
  end;
  mpf_set0(mak90);
  mpf_set0(mfqk90);
  if J > 0 then begin                 // ϕp90ȏȂ 90(/2) ϕ
    if s_mpf_is_le0(m1mk2) then begin
      ALFQK := 1;
      ALFRG := 1;                         // O
    end
    else begin
      mpf_set0(mc2);                      // cos^2(90) = 0
      mpf_set1(ms);                       // sin(90)   = 1
      mpf_set1(ms3);                      // sin^3(90) = 1
      MRF(mc2, m1mk2, mONE, mrf0);          // RF(x,y,z)
      mpf_mul(ms, mrf0, mTMP);              // sin*RF(x,y,z)
      mpf_copy(mrf0, mfqk90);               // F(90,k) = RF(x,y,z) * sin(90) = RF(x,y,z)
    end;
    if ALFRG = 0 then begin                 // O
      MRJ(mc2, m1mk2, mONE, m1mas2, mrj0);  // RJ(x,y,z,)
      mpf_div_int(ma, 3, ms2);              // a/3
      mpf_mul(ms2, ms3, mc2);               // a/3 * sin^3
      mpf_mul(mc2, mrj0, ms3);              // a/3 * sin^3 * RJ(x,y,z,)
      mpf_add(mtmp, ms3, mak90);            // F(90,k) + a/3 * sin^3 * RJ(x,y,z,)
    end;
  end;
  if J mod 2 <> 0 then begin      // eq = (j + 1) * pi / 2 - q یϕpvZ
    mpf_mul_int(mps2, J + 1, mTMP);
    mpf_sub(mTMP, mq, meq);
  end
  else begin                      // eq = q - (pi / 2 * j)     یϕpvZ
    mpf_mul_int(mps2, J, mTMP);
    mpf_sub(mq, mTMP, meq);
  end;
  mpf_cos(meq, ms);               // cos
  mpf_sqr(ms, mc2);               // cos^2
  mpf_sin(meq, ms);               // sin
  mpf_sqr(ms, ms2);               // sin^2
  mpf_mul(ms2, ms, ms3);          // sin^3
  mpf_mul(mm, ms2, mTMP);         // k^2sin^2
  mpf_set1(mONE);                 // 1
  mpf_sub(mONE, mTMP, m1mk2);     // 1 - k^2sin^2
  if s_mpf_is_neg(m1mk2) then mpf_set0(m1mk2);
  mpf_mul(ma, ms2, mTMP);         // a*sin^2
  mpf_sub(mONE, mTMP, m1mas2);    // 1 - a*sin^2
  if ALFQK = 0 then begin           // 
    MRF(mc2, m1mk2, mONE, mrf0);    // RF(x,y,z)
    mpf_mul(ms, mrf0, mTMP);        // fek := s * rf0;
    mpf_copy(mTMP, mfek);           // F(eq, k)
  end;
  if ALFRG = 0 then begin           // O
    MRJ(mc2, m1mk2, mONE, m1mas2, mrj0);   // RJ(x,y,z,)
    mpf_div_int(ma, 3, ms2);    // a/3
    mpf_mul(ms2, ms3, mc2);     // a/3 * sin^3
    mpf_mul(mc2, mrj0, ms3);    // a/3 * sin^3 * RJ(x,y,z,)
    mpf_add(mTMP, ms3, maek);   // F(eq, k) + a/3 * sin^3 * RJ(x,y,z,)
  end;
  if J mod 2 <> 0 then begin      // Q,Sی̐ϕl
    if ALFRG = 0 then begin
      mpf_mul_int(mak90, j + 1, mTMP);
      mpf_sub(mTMP, maek, mafk);       // (a,,k) = mafk := (j + 1) * mafk90 - maek;
    end;
    if ALFQK = 0 then begin
      mpf_mul_int(mfqk90, j + 1, mTMP);
      mpf_sub(mTMP, mfek, mfqk);       // F(,k)    = mfqk := (j + 1) * mfqk90 - mfek;
    end;
  end
  else begin                      // 1,3ی̐ϕl
    if ALFRG = 0 then begin
      mpf_mul_int(mak90, j, mTMP);
      mpf_add(mTMP, maek, mafk);       // (a,,k) = afk := j * mafk90 + maek;
    end;
    if ALFQK = 0 then begin
      mpf_mul_int(mfqk90, j, mTMP);
      mpf_add(mTMP, mfek, mfqk);       // F(,k)    = mfqk := j * mfqk90 + mfek;
    end;
  end;
  if s_mpf_is_neg(mqb) then begin    // ϕŕݒ
    s_mpf_chs(mafk);
    s_mpf_chs(mfqk);
  end;

LEXIT:
  case ALFRG of                                              // O
    0 : Edit2.Text := string(mpf_decimal_alt(mafk, 51));
    1 : if s_mpf_is_ge0(mqb) then Edit2.Text := 'INF'
                             else Edit2.Text := '-INF';
    2 : Edit2.Text := 'a()̒l傫܂B'
  end;
  case ALFQK of                                              // 
    0 : Edit6.Text := string(mpf_decimal_alt(mfqk, 51));
    1 : if s_mpf_is_ge0(mqb) then Edit6.Text := 'INF'
                             else Edit6.Text := '-INF';
  end;
//------------------------------------------------------------------

// ȉ~ϕ { -------------------------------------------
  ALFRG := 0;                               // vZtO     0   1  k̒l Zs
//  J := mp_get_int(mj);
  mpf_set0(mfqk90);
  mpf_set0(mfqk);
  if J > 0 then begin                     // 90ȏȂ
    mpf_set_int(mfqk, J);                   // mfqk = J
    mpf_mul_int(mps2, J, ms3);              // J *  / 2
    if mpf_is_eq_rel(mq, ms3) and mpf_is1(mm) then begin  // mpf_is_eq_rel 덷́
      // DoublẻZł̓rbgȂ̂ŁƂȂ܂Arbgɑ̂ŁAŏIrbgɍł܂
      goto MNo2;                              // j I
    end
    else
      if mpf_is_gt(mm, mONE) then begin     // m > 1 Ȃ
        ALFRG := 1;                          // G[tOZbg
        goto MNo2;                           // I
      end
      else begin                            // m <= 1 Ȃ 90(/2) ϕ
        if mpf_is1(mm) then                 // m = 1 Ȃ
          mpf_set1(mfqk90)                    // fqk90 = 1
        else begin                          // m < 1 Ȃ 90ϕlvZ
          mpf_set0(mc2);                      // cos^2(90) = 0
          mpf_set1(ms);                       // sin(90)   = 1
          mpf_set1(ms3);                      // sin^3(90) = 1
          mpf_sub(mONE, mm, m1mk2);           // 1 - k^2
          MRF(mc2, m1mk2, mONE, mrf0);        // RF(x,y,z)
          MRJ(mc2, m1mk2, mONE, mONE, mrj0);  // RD(x,y,z) = RJ(x,y,z,z)
          mpf_mul(ms, mrf0, mTMP);            // sin*RF(x,y,z)
          mpf_div_int(mm, 3, ms2);            // k^2 /3
          mpf_mul(ms2, ms3, mc2);             // k^2 /3 *sin^3
          mpf_mul(mc2, mrj0, ms3);            // k^2 /3 *sin^3 * RD(x,y,z)
          mpf_sub(mTMP, ms3, mfqk90);         // E(90,K) = sin*RF(x,y,z) - k^2 /3 *sin^3 * RD(x,y,z)
        end;
      end;
  end;
  if j mod 2 <> 0 then begin      // ' = eq = (j + 1) * pi / 2 - q  Q,Sی̐ϕpx
    mpf_mul_int(mps2, J + 1, mTMP);
    mpf_sub(mTMP, mq, meq);
  end
  else begin                      // ' = eq = q - (pi / 2 * j)      1,3ی̐ϕpx
    mpf_mul_int(mps2, J, mTMP);
    mpf_sub(mq, mTMP, meq);
  end;
  mpf_cos(meq, ms);               // cos
  mpf_sqr(ms, mc2);               // cos^2
  mpf_sin(meq, ms);               // sin
  mpf_sqr(ms, ms2);               // sin^2
  mpf_mul(ms2, ms, ms3);          // sin^3
  mpf_mul(mm, ms2, mTMP);         // k^2sin^2
//  mpf_set1(mONE);                 // 1
  mpf_sub(mONE, mTMP, m1mk2);     // 1 - k^2sin^2
  if s_mpf_is_neg(m1mk2) then mpf_set0(m1mk2);
//  mpf_abs(m1mk2, m1mk2);
  if s_mpf_is_ge0(m1mk2) then begin  // 1 - k^2sin^2 >= 0 Ȃ  ی̐ϕ
    if mpf_is_eq(mm, mONE) then begin  // m = 1 Ȃ
      mpf_sin(meq, maek);                // aek = sin()
    end
    else begin                         // m <> 1 Ȃ
      MRF(mc2, m1mk2, mONE, mrf0);
      MRJ(mc2, m1mk2, mONE, mONE, mrj0);    // RD(x,y,z) = RJ(x,y,z,z)

      mpf_mul(ms, mrf0, mTMP);        // F(,K) := s * rf0;
      mpf_div_int(mm, 3, ms2);        // k^2 /3
      mpf_mul(ms2, ms3, mc2);         // k^2 /3 *sin^2
      mpf_mul(mc2, mrj0, ms3);        // k^2 /3 *sin^3 * RD(x,y,z)
      mpf_sub(mTMP, ms3, maek);       // sin*RF(x,y,z) - k^2 /3 *sin^3 * RD(x,y,z)
    end;
  end
  else begin
    ALFRG := 1;
    goto MNo2;
  end;
  if j mod 2 <> 0 then begin      // E(,K) = (j + 1) * E(90,K) - E(',K) ی
    mpf_mul_int(mfqk90, j + 1, mTMP);
    mpf_sub(mTMP, maek, mfqk);
  end
  else begin                      // E(,K) = j * E(90,K) + E(',K);      ی
    mpf_mul_int(mfqk90, j, mTMP);
    mpf_add(mTMP, maek, mfqk);
  end;
MNo2:
  if s_mpf_is_neg(mqb) then s_mpf_chs(mfqk);              // ϕݒ
  case ALFRG of                                           // 
    0: Edit4.Text := string(mpf_decimal_alt(mfqk, 51));
    1: Edit4.Text := 'k(S)̒l傫܂B'
  end;
//-----------------------------------------------------------------

  mp_clear(mj);
  mpf_clear(mq);
  mpf_clear3(ms, ms2, ms3);
  mpf_clear(mc2);
  mpf_clear2(mrf0, mrj0);
  mpf_clear2(mafk, maek);
  mpf_clear2(m1mk2, m1mas2);
  mpf_clear(mak90);
  mpf_clear2(mONE, mTMP);
  mpf_clear(meq);
  mpf_clear(mps2);
  mpf_clear2(mfqk, mfek);
  mpf_clear(mfqk90);
  mpf_clear(meqk);
end;

// {͏Ƒ{ȉ~ϕ
// ma       O
// mq      pxrad
// mm      p[^[ k^2
procedure TForm1.Mdatainput;
var
  ch              : integer;
  msn, mpi, mk    : mp_float;
  meq, m90, mqg   : mp_float;
  deg             : mp_float;
  ma, mqb, mm     : mp_float;
  ma0, mb0        : mp_float;
  mone            : mp_float;
  mj              : mp_int;
  c               : char;
  l               : integer;
  kss, kstr       : string;
  mqbmax, tmp     : mp_float;
begin
  mpf_init3(msn, mpi, mk);
  mpf_init4(meq, m90, mqg, deg);
  mpf_init3(ma, mqb, mm);
  mpf_init3(ma0, mb0, mone);
  mp_init(mj);
  mpf_init2(mqbmax, tmp);

  mpf_set1(mone);
  mpf_set_pi(mpi);              // pi
  // 
  mpf_read_decimal(ma, PAnsiChar(ansistring(LabeledEdit1.Text + #00)));
  // ϕ͈ mq
  if btn2F then                         // w͈̔͌vZȂ
    mpf_copy(MpXtoDeg, deg)
  else begin                            // deg͈̔͂Ȃ
    mpf_read_decimal(deg, PAnsiChar(ansistring(LabeledEdit2.Text + #00)));
    mpf_copy(deg, MpXtoDeg)
  end;
  mpf_div_int(deg, 180, msn);           // deg -> rad msn = phi / 180
  mpf_mul(msn, mpi, mqb);               // mq =  msn * pi     ϕpx(rad)
  // p[^m
  if radiobutton1.Checked then begin    // Skw
    kstr := k_edit.Text;
    l       := length(kstr);                     // ̒擾
    c       := kstr[l];                          // i̕mF
    if (c = 'i') or (c = 'I') then begin         // iw肾@̕擾
      c  := 'i';                                 // tOZbg
      kss   := copy(kstr, 1, l - 1);             // ȋO܂ŃRs[
    end
    else Kss := kstr;
    mpf_read_decimal(mk, PAnsiChar(ansistring(kss + #00)));
    mpf_sqr(mk, mm);                    // m = k^2
    if c = 'i' then mpf_chs(mm, mm);    // m := -m
    if mpf_is_gt(mm, mone) then begin
//    if mm > 1 then begin
      mpf_abs(mk, tmp);                 // abs(k)
      mpf_div(mone, tmp, tmp);          // 1 / k
      mpf_arcsin(tmp, mqbmax);         // arcsin(1/k)
      mpf_abs(mqb, tmp);                // abs(qb)
      if mpf_is_gt(tmp, mqbmax) then begin
//      if abs(qb) > qbmax then begin
        if s_mpf_is_neg(deg) then mpf_chs(mqbmax, mqbmax);
//        if deg < 0 then qb := -qb;
        mpf_copy(mqbmax, mqb);
//        qb := qbmax;
      end;
    end;
  end;
  if radiobutton2.Checked then  begin         // p[^mw
    mpf_read_decimal(mm, PAnsiChar(ansistring(LabeledEdit5.Text + #00)));
    if s_mpf_is_gt0(mm) then mpf_sqrt(mm, mk);
//    if m > 0 then k := sqrt(m);
    if mpf_is_gt(mm, mone)  then begin
//    if m > 1 then begin
      mpf_div(mone, mk, tmp);                 // 1/k
      mpf_arcsin(tmp, mqbmax);                // ϕ\ől arcsin(1/k)
      mpf_abs(mqb, tmp);                      // abs(qb)
      if mpf_is_gt(tmp, mqbmax) then begin
//      if abs(qb) > qbmax then begin
        if s_mpf_is_neg(deg) then mpf_chs(mqbmax, mqbmax);
//        if deg < 0 then qb := -qb;
        mpf_copy(mqbmax, mqb);
//        qb := qbmax;
      end;
    end;
  end;
  if radiobutton3.Checked then begin    // a(a,b)w
    mpf_read_decimal(ma0, PAnsiChar(ansistring(aEdit.Text + #00)));
    mpf_read_decimal(mb0, PAnsiChar(ansistring(bEdit.Text + #00)));
    mpf_mul(mb0, mb0, mb0);
    mpf_mul(ma0, ma0, ma0);
    mpf_div(mb0, ma0, mm);
    mpf_sub(mone, mm, mm);
//    m := 1 - b0 * b0 / a0 / a0;
  end;

  mpf_div(mqb, mpi, tmp);             // qb -> qb / pi
  mpf_mul_int(tmp, 180, deg);         // deg = qb / pi * 180    ϕpx(deg)

  //----- start --- deg -> X vZ \p -------------
  mpf_abs(deg, mqg);          // qb = abs(deg)
  mpf_div_int(mqg, 90, meq);  // eq = qb / 90
  mpf_trunc(meq, mj);         // j = int(eq)
  ch := mp_get_int(mj);       // j -> ch   integer
  mpf_set_int(m90, 90);
  if ch mod 2 <> 0 then begin // eq = (j + 1) * 90 - qb   ی
    mpf_mul_int(m90, ch + 1, m90);
    mpf_sub(m90, mqg, meq);
  end
  else begin                    // eq = qb - (90 * j)       ی
    mpf_mul_int(m90, ch, m90);
    mpf_sub(mqg, m90, meq);
  end;
  mpf_div_int(meq, 180, msn);   // sn = eq / 180@
  mpf_mul(msn, mpi, meq);       // eq = sn * pi
  mpf_sin(meq, msn);            // sn = sin(eq)
  if ch mod 2 <> 0 then begin   // eq = (ch + 1) - sin(eq);  ی
    mpf_set_int(m90, ch + 1);
    mpf_sub(m90, msn, msn);
  end
  else begin                    // ch + sin(eq)              ی
    mpf_add_int(msn, ch, msn);
  end;
  if s_mpf_is_neg(deg) then mpf_chs(msn, msn);     // ݒ

  //----- end --- deg -> X@--------------------------
  if not btn2F then begin
    Xstr   := string(mpf_decimal_alt(msn, 70));        // X̒lobNAbv
    Label2.Caption := 'ϕ͈ = ' + string(mpf_decimal_alt(deg, 20)) + ' deg';
    Label3.Caption := 'ϕ͈ w= ' + string(mpf_decimal_alt(msn, 20));
  end;
  // ---- max  calc@----------------------------

  mpf_set_pi(m90);                  // pi
  mpf_div_int(m90, 2, m90);         // pi/2
  if mpf_is_ge(mqb, m90) then mpf_set1(msn)       // 1
                        else mpf_sin(mqb, msn);   // sin
  mpf_sqr(msn, meq);                // sin^2()
  if s_mpf_is_gt0(meq) then begin   // sin^2() > 0
    mpf_inv(meq, mqg);              // 1 / sin^2()
    Label6.Caption := '(n)̏l = ' + string(mpf_decimal_alt(mqg, 20));
  end
  else
    Label6.Caption := '(n)̏l = ';
  // {ȉ~ϕ
  //-----------------------------------------------
  Mcalc_Third_elliptic_integral(ma, mqb, mm);
  button3.Enabled := true;

  mpf_clear3(msn, mpi, mk);
  mpf_clear4(meq, m90, mqg, deg);
  mpf_clear3(ma, mqb, mm);
  mpf_clear3(ma0, mb0, mone);
  mp_clear(mj);
  mpf_clear2(mqbmax, tmp);
end;

//==============================================================================
// Carlson's Elliptic Integral RJ
function RJ(x1, y1, z1, p1: double): double;
var
  s, fa, rj, rk   : double;
  la, mu          : double;
  al, be          : double;
  r1, a1, b1      : double;
  a2, b2, mv, s1  : double;
  rc, r0          : double;
  s12, s13, s14   : double;
  s15, s16        : double;
  x2, y2, z2      : double;
  x3, y3, z3      : double;
  s2, s3, p2, p3  : double;
  s4, s5          : double;
  x31, y31, z31, p31 : double;
  s22, s23, s2s3  : double;

  procedure rcab;
  begin
    rc := 1;
    a1 := al;
    b1 := be;
    repeat
      r1 := rc;
      la := 2 * sqrt(a1 * b1) + b1;
      a2 := (a1 + la) / 4;
      b2 := (b1 + la) / 4;
      mv := (a1 + 2 * b1) / 3;
      s1 := (b1 - a1) / (3 * mv);
      s12 := s1 * s1;
      s13 := s12 * s1;
      s14 := s13 * s1;
      s15 := s14 * s1;
      s16 := s15 * s1;
      rc := (1 + 3 * s12 / 10 + s13 / 7 + 3 * s14 / 8 + 9 * s15 / 22 + 159 * s16 / 208) / sqrt(mv);
      a1 := a2;
      b1 := b2;
    until r1 = rc;
  end;

  function ss: double;
  begin
    x31 := x31 * x3;
    y31 := y31 * y3;
    z31 := z31 * z3;
    p31 := p31 * p3;
    result := (x31 + y31 + z31 + p31);
  end;

begin
  s := 0;
  fa := 3;
  rj := 0;
  repeat
    r0 := rj;
    la := sqrt(x1 * y1) + sqrt(x1 * z1) + sqrt(y1 * z1);
    mu := (x1 + y1 + z1 + 2 * p1) / 5;
    x2 := (x1 + la) / 4;
    y2 := (y1 + la) / 4;
    z2 := (z1 + la) / 4;
    p2 := (p1 + la) / 4;
    x3 := 1 - x1 / mu;
    y3 := 1 - y1 / mu;
    z3 := 1 - z1 / mu;
    p3 := 1 - p1 / mu;
    x31 := x3;
    y31 := y3;
    z31 := z3;
    p31 := 2 * p3;
    s2 := ss / 4;
    s3 := ss / 6;
    s4 := ss / 8;
    s5 := ss / 10;
    al := (sqrt(x1) + sqrt(y1) + sqrt(z1)) * p1 + sqrt(x1 * y1 * z1);
    al := al * al;
    be := p1 * (p1 + la) * (p1 + la);
    rcab;
    s22 := 3 * s2 * s2 / 22;
    s23 := s2 * s2 * s2 / 10;
    s2s3 := s2 * s3 * 3 / 13;
    s := s + fa * rc;
    rk := 1 + 3 * s2 / 7 + s3 / 3 + s22 + s2s3 + 3 * s4 / 11 + 3 * s5 / 13 - s23;
    fa := fa / 4;
    mu := sqrt(1 / (mu * mu * mu));
    rj := s + fa / 4 * (rk + 3 * s3 * s3 / 10 + 3 * s2 * s4 / 5) * mu;
    x1 := x2;
    y1 := y2;
    z1 := z2;
    p1 := p2;
  until rj = r0;
  result := rj;
end;

// Carlson's Elliptic Integral RF
function RF(x1, y1, z1: double): double;
var
  la, mu      : double;
  x2, y2, z2  : double;
  x3, y3, z3  : double;
  s2, s3      : double;
  r0, rf      : double;
  s22, s23, s2s3, s32 : double;
begin
  rf := 0;
  repeat
    r0 := rf;
    la := sqrt(x1 * Y1) + sqrt(x1 * z1) + sqrt(y1 * z1);
    mu := (x1 + y1 + z1) / 3;
    x2 := (x1 + la) / 4;
    y2 := (y1 + la) / 4;
    z2 := (z1 + la) / 4;
    x3 := 1 - x2 / mu;
    y3 := 1 - y2 / mu;
    z3 := 1 - z2 / mu;
    s2 := (x3 * x3 + y3 * y3 + z3 * z3) / 4;
    s3 := (x3 * x3 * x3 + y3 * y3 * y3 + z3 * z3 * z3) / 6;
    s22 := s2 * s2 / 6;
    s23 := 5 * s2 * s2 * s2 / 26;
    s32 := 3 * s3 * s3 / 26;
    s2s3 := s2 * s3 * 3 / 11;
    rf := (1 + s2 / 5 + s3 / 7 + s22 + s2s3 + s23 + s32) / sqrt(mu);
    x1 := x2;
    y1 := y2;
    z1 := z2;
  until rf = r0;
  result := rf;
end;


// AAOȉ~ϕ
// a       O
// m      p[^ k^2
// qb     rad px
procedure TForm1.calc_Third_elliptic_integral(a, qb, m: double);
label
  No2;
var
//  DBL_EPSILON : double;         // ŏ덷
  J           : integer;
  s, s2, s3   : double;
  c2          : double;
  rf0, rj0    : double;
  afk, aek    : double;
  afk90       : double;
  q, eq       : double;
  fqk, fek    : double;
  fqk90       : double;
  rd0         : double;
  eqk, eek    : double;
  eqk90       : double;
  pis2        : double;
  mss2        : double;
  MKFRG       : integer;                    // vZtO     0   1 }
  ALFRG       : Integer;                    // OvZtO     0   1 }  2 Oa̒l Zs
begin
// Oȉ~ϕ --------------------------------------------
  afk := 0;                                 // Oϕl
  aek := 0;                                 // ϕl
  ALFRG := 0;
  MKFRG := 0;
  q := abs(qb);
  fqk := 0;
  pis2 := pi / 2;      // 32bit pi/2 > pis2  pi(extended) pis2(double) 64bit pi(double)
{
 32rbgRpC̏ꍇ q /(pi/2) ̌vZ q double pi/2 extended q/(pi/2)̉Zextended
 Z90180270360̒l1,2,3,4̐ɂȂ܂̂ pi/2 (extende) -> pis2(double)
 ϊČvZ܂B
 64rbgRpC̏ꍇ́ASdoubleɂȂ̂Ŗ肠܂B
 vȌCɂϕp90J0ɂȂ悤ȂDBL_EPSILOŇvZLɂ܂
}
//  DBL_EPSILON := power(2, -52);
//  J := trunc((q  + q * DBL_EPSILON ) / (pi / 2));
  J := trunc(q / pis2);                         // یvZ_ȉ؂̂ 0,1,2,3,4
  if J > 0 then begin                           // 90ȏゾ
    s2 := 1;                                      // sin^2(90)=1
  end
  else begin                                    // 90ȉȂ
    s  := sin(q);                                 // sin()
    s2 := s * s;                                  // sin~2()
  end;
  if J mod 2 <> 0 then eq := (J + 1) * pis2 - q   // Q,Sی̐ϕpx
                  else eq := q - (pis2 * J);      // 1,3ی̐ϕpx
  if eq < 0 then eq := 0;                       // eq 0ȉ͖̂0ȉ͌덷Ȃ̂0ݒ
  if (1 - a * s2) <= 0 then begin             // a̒l傫
    if (1 - a * s2) = 0 then begin
      ALFRG := 1;                             // O tOZbg
      if qb >= 0 then afk := infinity           // O = ''
                 else afk := -infinity;         // O = '-'
    end
    else
      ALFRG := 2;                          // 1-a^2*sin^2() }CiXtOZbg
  end;
  afk90 := 0;                                 // O90ϕl
  fqk90 := 0;                                 // 90ϕl
  if J > 0 then begin                         // 90ȏゾ 90x̐ϕvZ
    if m = 1 then begin
      if qb > 0 then begin
        fqk := infinity;
        afk := infinity;
      end
      else begin
        fqk := -infinity;
        afk := -infinity;
      end;
      MKFRG := 1;
      ALFRG := 1;                             // O tOZbg
    end
    else begin
      rf0 := RF(0, 1 - m, 1);                   // 90RFvZ
      if ALFRG = 0 then begin                   // OvZsȂ
        rj0 := RJ(0, 1 - m, 1, 1 - a * 1);      // 90RjvZ
        afk90 := rf0 + a / 3 * rj0;             // 90x̐ϕl O (a, 90,K)
      end;
      fqk90 := rf0;                             // 90x̐ϕl  rf0 * sin90= rf0 * 1 = F(90,K)
    end;
  end;
  c2 := cos(eq) * cos(eq);                    // cos^2(')   ی̐ϕvZJn
  s  := sin(eq);                              // sin(')
  s2 := s * s;                                // sin^2(')
  s3 := s2 * s;                               // sin^3(')
  mss2 := 1 - m * s2;                         // 1 - sin^2(')
  if mss2 < 0 then mss2 := 0;                 // 1 - sin^2(') < 0 Ȃ 0
  rf0 := RF(c2, mss2, 1);                   // p
  fek := s * rf0;                             // F(',K) = rf0 * sin(')  ی̐ϕl
  if ALFRG = 0 then begin                     // OvZsȂ
    rj0 := RJ(c2, mss2, 1, 1 - a * s2);
    aek := fek + a / 3 * s3 * rj0;            // (a,',K)                Oی̐ϕl
  end;
  if j mod 2 <> 0 then begin                  // Q,Sی̐ϕl
    if ALFRG = 0 then afk := (j + 1) * afk90 - aek;     // O
    if MKFRG = 0 then fqk := (j + 1) * fqk90 - fek;     // 
  end
  else begin                                  // 1,3ی̐ϕl
    if ALFRG = 0 then afk := j * afk90 + aek;   // O
    if MKFRG = 0 then fqk := j * fqk90 + fek;   // 
  end;
  if qb < 0 then begin                        // ϕ͈͂̕Őϕl̕ݒ
    if ALFRG = 0 then afk := - afk;             // O
    if MKFRG = 0 then fqk := - fqk;                               // 
  end;
  case ALFRG of                                 // O
    0,1 : Edit1.Text := floatTostr(afk);
    2 : Edit1.Text := 'a(n)̒l傫'
  end;
  Edit5.Text := floatTostr(fqk);                // 

//------------------------------------------------------------------

// ȉ~ϕ --------------------------------------------------
  ALFRG := 0;                       // vZtO     0   1  k̒l Zs
  eqk90 := 0;                       // 90ϕl
  if J > 0 then begin               // ϕ͈90x傫
    eqk := J * pis2;
//    90̐{m=1̎A~XꍇDBL_EPSILONLɂ܂
//    if (abs(q - eqk) <= eqk * DBL_EPSILON) and (m = 1) then begin  // px90̐{ m1 Ȃ
    if (q = eqk) and (m = 1) then begin  // px90̐{ m1 Ȃ
      eqk := J;                                 // J
      goto No2;
    end
    else                              // px90̐{łȂ m1 łȂȂ
      if m > 1 then begin           // m P傫
        ALFRG := 1;                   // m̒l傫tOZbg
        goto No2;
      end
      else begin                    // m̒lP͂PȉȂ90̐ϕlvZ
        if m = 1 then eqk90 := 1      // m = 1 Ȃ90̒l 1
        else begin                    // m <> 1 ̏ꍇ 90̐ϕlvZ
          rf0 := RF(0, 1 - m, 1);
          rd0 := RJ(0, 1 - m, 1, 1);
          eqk90 := rf0 - m / 3 * rd0;  // 90̐ϕlrf0 | k^2 / 3 * RD
        end;
      end;
  end;
  s  := sin(eq);                      // sin(')
  s2 := s * s;                        // sin^2(')
  if m = 1 then begin              // m = 1 Ȃ
    eek := sin(eq);                  // eek = sin(')
  end
  else begin
    c2 := cos(eq) * cos(eq);                // cos^2(')
    s3 := s2 * s;                           // sin^3(')
    rf0 := RF(c2, mss2, 1);
    rd0 := RJ(c2, mss2, 1, 1);
    eek := s * rf0 - m / 3 * s3 * rd0;      // eek = ی̑Qϕl
  end;
  if j mod 2 <> 0 then eqk := (J + 1) * eqk90 - eek   // Q,Sی̐ϕl
                  else eqk := J * eqk90 + eek;        // P,Rی̐ϕl

NO2:
  if qb < 0 then eqk := - eqk;            // ϕpxZbg
  case ALFRG of                           // 
    0: Edit3.Text := floatTostr(eqk);
    1: Edit3.Text := 'k(S)̒l傫܂B'
  end;
end;

// {xvZpf[^[͂Ɣ{xȉ~ϕvZ
procedure TForm1.Ddatainput;
var
  k, deg, pai : double;
  a, qb, m    : double;
  a0, b0      : double;
  c           : char;
  kss, kstr   : string;
  l           : integer;
  qbmax       : double;
begin
  m := 0;
  pai := pi;                              // bit΍pi(double)paiɃZbg(vZ̓)
  a := strtofloat(LabeledEdit1.Text);     // ̒l
  if btn2F then                           // w͈̔͌vZȂ
    deg := DbXtoDeg
  else                                    // degwvZȂ
    deg := strtofloat(LabeledEdit2.Text);
  qb := pai * deg / 180;                  // deg -> rad ϊ
  if radiobutton1.Checked then begin      // Skw
    kstr := k_edit.Text;
    l       := length(kstr);                     // ̒擾
    c       := kstr[l];                          // i̕mF
    if (c = 'i') or (c = 'I') then begin         // iw肾
      c  := 'i';                                 // tOZbg
      kss   := copy(kstr, 1, l - 1);             // ȋO܂ŃRs[
    end
    else Kss := kstr;
    k := strtofloat(Kss);
    m       := k * k;
    if c = 'i' then m := -m;                    //  m = -m
    if m > 1 then begin                         // łȂm > 1Ȃ
      qbmax := arcsin(1 / abs(k));              // ϕ\őpxvZ
      if abs(qb) >= qbmax then begin
        if deg < 0 then qbmax := -qbmax;
        qb := qbmax;
      end;
    end;
  end;
  if radiobutton2.Checked then begin        // p[^mw
    m := strTofloat(LabeledEdit5.Text);
    if m > 1 then begin
      k := sqrt(m);
      qbmax := arcsin(1 / k);
      if abs(qb) >= qbmax then begin
        qb := qbmax;
        if deg < 0 then qb := -qb;
      end;
    end;
  end;
  if radiobutton3.Checked then begin        // a(a,b)w
    a0 := strTofloat(aEdit.Text);
    b0 := strTofloat(bEdit.Text);
    m := 1 - b0 * b0 / a0 / a0;
  end;
  calc_Third_elliptic_integral(a, qb, m); // {xȉ~ϕ
end;

// ̓G[mF
// a       O
// m      p[^ k^2
// deg    px
function TForm1.datacheck: boolean;
var
  a, m, deg           : double;
  ch, l               :integer;
  degmax, kmax, k, q  : double;
  a0, b0              : double;
  kstr, kss           : string;
  c                   : char;
begin
  result := False;
  val(LabeledEdit1.Text, a, ch);
  if ch <> 0 then begin
    application.MessageBox('a()̒lɊԈႢ܂B','a()',0);
    exit;
  end;
  if btn2F then                     // w͈̔͌vZȂ
    deg := DbXtoDeg
  else                              // degwvZȂ
    val(LabeledEdit2.Text, deg, ch);
  if ch <> 0 then begin
    application.MessageBox('(deg)̒lɊԈႢ܂B','(deg)',0);
    exit;
  end;
// vZpx̏͂܂񂪂ꉞ+-360Ō
  if abs(deg) > 360 then begin
    application.MessageBox('360(deg)-360̒l͈͊OłB','(deg)',0);
    exit;
  end;
  k := 0;
  m := 0;
  if radiobutton1.Checked then begin   // Skw
    kstr := k_edit.Text;
    if kstr = '' then begin
      application.MessageBox('Sk̒l܂B','',0);
      exit;
    end;
    l       := length(kstr);                     // ̒擾
    c       := kstr[l];                          // i̕mF
    if (c = 'i') or (c = 'I') then begin         // iw肾@̕擾
      kss   := copy(kstr, 1, l - 1);             // ȋO܂ŃRs[
    end
    else Kss := kstr;
    val(Kss, k, ch);
    if ch <> 0 then begin
      application.MessageBox('Sk̒lɊԈႢ܂B','',0);
      exit;
    end;
  end;
  if radiobutton2.Checked then begin   // p[^[mw
    val(LabeledEdit5.Text, m, ch);
    if ch <> 0 then begin
      application.MessageBox('p[^[()̒lɊԈႢ܂B','p[^[()',0);
      exit;
    end;
    if m >= 0 then k := sqrt(m)
              else k := 0;
  end;
  if radiobutton3.Checked then begin   // aa,bw
    val(aEdit.Text, a0, ch);
    if ch <> 0 then begin
      application.MessageBox('a(a)̒lɊԈႢ܂B','p[^[()',0);
      exit;
    end;
    val(bEdit.Text, b0, ch);
    if ch <> 0 then begin
      application.MessageBox('a(b)̒lɊԈႢ܂B','p[^[()',0);
      exit;
    end;
    m := 1 - b0 * b0 / a0 / a0;
    if m > 0 then k := sqrt(m)
             else k := 0;
  end;
  q := deg * pi / 180;
  if abs(q) > pi / 2 then  q := pi / 2;
  kmax := sin(q);
  kmax := 1 / kmax;
  Label8.Caption := 'px' + floattostr(deg) + '' + 'k(S)l= }' + floattostr(kmax);
  if abs(k) > kmax then begin
    degmax := arcsin(1 / abs(k)) / pi * 180;
    if abs(deg) > degmax then begin
      if k < 0 then kmax := -kmax;
      if deg < 0 then degmax := -degmax;
      application.MessageBox(pchar('px̍ől' + floatTostr(degmax) + #13#10
        + '͗S̍ől' + floatTostr(kmax) + 'łB'),'k(S)',0);
    end;
  end;
  if m > kmax  * Kmax then begin
    degmax := arcsin(1 / k) / pi * 180;
    if abs(deg) > degmax then begin
      application.MessageBox(pchar('px̍ől' + floatTostr(degmax) + #13#10
        + '̓p[^(m)̍ől' + floatTostr(kmax * Kmax) + 'łB'),'m(p[^)',0);
    end;
  end;
// (l)̏́Aϕ͈̔sin(q)ŕω܂B
  if ((q < pi / 2) and (sin(q) * sin(q) * a > 1)) or ((q >= pi / 2) and (a >= 1)) then begin
    application.MessageBox('ϕ͈̔́@́@a()̒l傫܂B' + #13#10
                            + 'AOϕ傩G[ɂȂ܂B','(deg), a()',0);
  end;
  result := true;
end;

// ϕ͈͊pxwvZ
procedure TForm1.Button1Click(Sender: TObject);
begin
  btn2f := False;      // pxvZɃtOZbg
  // ̓`FbN
  if not datacheck then exit;
  // {xvZ
  Ddatainput;
  // {vZ
  Mdatainput;
end;

// ϕ͈ X wϕvZ
procedure TForm1.Button2Click(Sender: TObject);
label
  EXD;
var
  X                   : double;
  ch, J               : integer;
  Xm, acsn, xem, m90  : mp_float;
  mps2, mpi, Xinm          : mp_float;
  mj                  : mp_int;
  Mflag               : boolean;
begin
  val(LabeledEdit4.Text, X, ch);
  if ch <> 0 then begin
    application.MessageBox('X(4X-4)̒lɊԈႢ܂B','X(4X-4)',0);
    exit;
  end;
  if (X > 4) or (X < -4) then begin
    application.MessageBox('X(4X-4)̒l͈͊OłB','X(4X-4)',0);
    exit;
  end;

  mpf_init4(xm, acsn, xem, m90);
  mpf_init3(mps2, mpi, Xinm);
  mp_init(mj);

  // Xtext {xinmɕϊ
  mp_real.mpf_read_decimal(xinm, PAnsiChar(ansistring(LabeledEdit4.Text + #00)));
  // X̒lxinmpxdegɕϊ
  Mflag := false;               // }CiXtOZbg
  if s_mpf_is_neg(xinm) then Mflag := true;  // xinm̒l||tOZbg
  mpf_abs(xinm, xm);                         // Ȃx  xm
  mpf_trunc(xm, mj);                         // _ȉ؂̂ 
  j := mp_get_int(mj);                       // { -> integer
  mpf_set_pi(mpi);                          // pi Zbg
  mpf_div_int(mpi, 2, mps2);                // pi / 2
  if j mod 2 = 0 then begin             // 1,3ی
    mpf_sub_int(xm, j, xem);                // xe = x - j  o
    mpf_arcsin(xem, acsn);                  // sin^-1(xe)  ->rad@
  end
  else begin                            // 2,4ی  A[NTC̕t
    mpf_set_int(xem, j + 1);
    mpf_sub(xem, xm, xem);                  // xem = j + 1 - x  o
    mpf_arcsin(xem, acsn);                  // sin^-1(xem)      ->rad@
    mpf_sub(mps2, acsn, acsn);              // pi / 2 - sin^-1(xem) px]
  end;
  mpf_set_int(m90, 90);                     // 90
  mpf_div(acsn, mpi, acsn);                 // rad / pi
  mpf_mul_int(acsn, 180, xm);               // rad / pi * 180
  mpf_mul_int(m90, j, xem);                 //  * 90
  // px̒lϕvZɓnSO[oϐɃZbg
  mpf_add(xm, xem, MpXtoDeg);               // px + px
  if Mflag then mpf_chs(MpXtoDeg, MpXtoDeg);            // px̕Zbg
  // px̒lDoubleϕvZɓn߃O[oDoubleɕϊ
  DbXtoDeg := mpf_todouble(MpXtoDeg);

  Xstr   := labelededit4.Text;      // labelededit4.Text(w̕)obNAbv
  Label2.Caption := 'ϕ͈  =' + string(mpf_decimal_alt(MpXtoDeg, 20)) + ' deg';
  Label3.Caption := 'ϕ͈ w =' + string(mpf_decimal_alt(xinm, 20));

  btn2F := true;      // ͈ X wϕvZtOZbg
  // ̓`FbN
  if not datacheck then goto EXD;           // ̓G[LI
  // {xvZ
  Ddatainput;
  // {vZ
  Mdatainput;
  button3.Enabled := true;
EXD:
  mpf_clear4(xm, acsn, xem, m90);
  mpf_clear3(mps2, mpi, Xinm);
  mp_clear(mj);
end;

// ϕvZ@vZ̊pxX̒lBoxɃRs[܂B
procedure TForm1.Button3Click(Sender: TObject);
begin
  labelededit2.Text := string(mpf_decimal_alt(MpXtoDeg, 70));
  labelededit4.Text := Xstr;
end;

// ϕ͈͓Box̃NA(vZ̒lRs[ƒlȂ̂ŊȒPɏ܂)
procedure TForm1.Button4Click(Sender: TObject);
begin
  labelededit2.Text := '';
  labelededit4.Text := '';
end;

// I
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  mpf_clear(MpXtoDeg);
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  button3.Enabled := false;
  Label7.Caption := '() {ZƔ{xZł͉Z덷̍ɂA()A͒l̑傫̂ɑ΂锻̍ł܂B';
  mpf_init(MpXtoDeg);
end;

end.
